-module(counter).
-export([start/0,loop/1]).

start() ->
% Pid = spawn(Module,Function,Args)
    spawn(counter, loop, [0]).

loop(Val) ->
    receive
        inc -> loop(Val + 1); % tail recursive call
        reset -> loop(0);  % tail recursive call
        val -> io:format("Val is ~p~n",[Val]),
               loop(Val); % tail recursive call
        stop -> io:format("~p says bye!~n",[self()]);  % NO recursive call
        _ -> loop(Val) % other messages are discarded
    end.

% c(counter).
% Cnt = counter:start().
% Cnt ! Cnt ! Cnt ! Cnt ! inc.
% Cnt ! val.
% Cnt ! reset.
% Cnt ! val.
% Cnt ! stop.
