-module(icounter).
-export([start/0,loop/1,inc/1,val/1,reset/1,stop/1]).

start() ->
    spawn(icounter, loop, [0]).

loop(Val) ->
    receive
        inc -> loop(Val + 1); 
        reset -> loop(0);  
        {From,val} -> From ! {self(),Val}, % RECEIVE AND REPLY
                      loop(Val); 
        stop -> io:format("~p says bye!~n",[self()]);
        _ -> loop(Val)
end.

% functions over counters
inc(Counter) -> 
    Counter ! inc.

val(Counter) ->
    Counter ! {self(),val}, % SEND REQUEST
    receive
        {Counter,Value} -> Value; % WAIT FOR REPLY
        _ -> true
    end.

reset(Counter) ->
    Counter ! reset.

stop(Counter) ->
    Counter ! stop.

% c(icounter).
% Cnt = icounter:start().
% icounter:inc(Cnt).
% icounter:inc(Cnt).
% icounter:inc(Cnt).
% icounter:inc(Cnt).
% icounter:val(Cnt).
% icounter:reset(Cnt).
% icounter:val(Cnt).
% icounter:stop(Cnt).

